/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "class COUNTDOWN {\n    int noch;\n    \n    COUNTDOWN(int stufen) {\n        this.noch = stufen;\n    }\n    boolean countdown() {\n        if (this.noch > 0) {\n            this.noch = this.noch - 1;\n        }\n        return (this.noch != 0);\n    }\n}\n\nCOUNTDOWN countdown = new COUNTDOWN(3);\nwhile (countdown.countdown()) {\n    println(countdown.noch + 1);\n}\nprint(\"Los!\");",
	"classes": [
		{
			"className": "COUNTDOWN",
			"atts": [],
			"abstract": true
		}
	],
	"notSelectable": [
		2,
		5,
		9,
		11,
		12,
		13,
		17
	],
	"methodCalls": [
		3,
		6
	],
	"classDeclarations": [
		{
			"line": 0,
			"className": "COUNTDOWN"
		}
	],
	"steps": [
		{
			"line": -1,
			"vars": {
				"instances": [],
				"vars": [],
				"scopes": []
			},
			"task": "<p>Führe das Programm aus. Lies die ab dem nächsten Schritt angezeigte Hilfe nur, wenn du sonst nicht weiter weißt.</p>\n<p>Bereit? Dann starte jetzt, indem du die erste Zeile nach der Klassendefinition auswählst!</p>"
		},
		{
			"task": "Lege zunächst eine Variable vom Typ <code>COUNTDOWN</code> namens <code>countdown</code> an. Den Wert kannst du erst zuweisen, nachdem du das neue Objekt erzeugt hast. Starte damit, indem du die erste Zeile der Klassendefinition (<code>class COUNTDOWN {</code>) auswählst.",
			"line": 14,
			"vars": [],
			"cout": "",
			"enableTextOut": true
		},
		{
			"task": "<p>Zunächst müssen wir nur die Deklarationen der Attribute beachten. Alle Methoden und so weiter kannst du zunächst überspringen.</p>\n<p>In dieser Klasse gibt es nur eine einzige Deklaration eines Attributes: Die Zeile <code>int noch;</code>. Wähle sie aus!</p>",
			"line": 0,
			"vars": [
				{
					"key": "countdown",
					"type": "COUNTDOWN",
					"ref": null
				}
			]
		},
		{
			"task": "Erzeuge nun diese Variable. Du hast bereits alle Attribute dem Objekt hinzugefügt, mehr gibt es nicht. Allerdings gibt es einen Konstruktor, der muss am Ende der Objekterzeugung ausgeführt werden. Rufe ihn (<code>COUNTDOWN(int stufen) {</code>) also auf.",
			"line": 1,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "COUNTDOWN",
						"line": 14,
						"vars": []
					}
				]
			}
		},
		{
			"task": "Durch den Aufruf des Konstruktors wurde das Objekt automatisch in den Speicher eingetragen. Es hat die Adresse <code>@0000</code> erhalten. Jetzt behandelst du den Konstruktor wie jede andere Methode: Wähle als Wert für <code>this</code> die Adresse des aktuellen Objektes aus (<code>@0000</code>). Und lege für den einzigen Parameter (<code>int stufen</code>) eine Variable an. Ihr Wert muss <code>3</code> sein, weil das der Parameterwert im Methodenaufruf ist. Fahre dann mit der nächsten Zeile fort.",
			"line": 3,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "COUNTDOWN",
						"line": 14,
						"vars": [
							{
								"key": "noch",
								"type": "int",
								"value": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "<p>Das ist eine Wertezuweisung: Weil <code>this</code> auf das Objekt mit der Adresse <code>@0000</code> zeigt, musst du von diesem Objekt den Wert des Attributs <code>noch</code> ändern. Und zwar auf den Wert, den aktuell die Variable <code>stufen</code> hat, also <code>3</code>.</p>\n<p>Nach der Wertezuweisung ist der Konstruktor vollständig abgearbeitet. Schließe den Methodenaufruf ab, indem du dort auf ❌ klickst. Dadurch springst du automatisch zurück in die Zeile, die den Methodenaufruf bewirkt hat. Nun kannst du die Wertezuweisung <code>countdown = new COUNTDOWN(3)</code> ausführen, also der Variable <code>countdown</code> das Ergebnis von <code>new COUNTDOWN(3)</code> zuweisen: Die Adresse des neu erzeugten Objektes. Wähle dann die nächste Zeile aus.</p>",
			"line": 4,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 14,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "stufen",
								"type": "int",
								"value": 3
							}
						]
					}
				]
			}
		},
		{
			"task": "Bei <code>while</code> musst du immer prüfen, ob die in Klammern stehende Bedingung den Wert <code>true</code> ergibt, also wahr ist. In diesem Fall ist die Bedingung der Methodenaufruf <code>countdown.countdown()</code>. Rufe daher zunächst die Methode <code>countdown</code> der Klasse <code>COUNTDOWN</code> auf.",
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Bei jedem Methodenaufruf musst du zunächst den Wert von <code>this</code> richtig festsetzen. Weil der Methodenaufruf <code>countdown.countdown()</code> lautete, bekommt <code>this</code> den Wert von <code>countdown</code>, also die Adresse <code>@0000</code>. Da es keine Parameter gibt, geht es direkt mit der nächsten Zeile weiter.",
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Prüfe, ob die Bedingung in der Klammer erfüllt ist. Die Bedingung ist der Vergleich <code>this.noch &gt; 0</code>. Zunächst ermittelst du, was <code>this.noch</code> gerade für einen Wert hat: Da <code>this</code> die Adresse <code>@0000</code> enthält, kannst du den Attributwert von <code>noch</code> bei diesem Objekt ablesen. Prüfe, ob diese Zahl wirklich größer als <code>0</code> ist. Wenn ja, geht es in der nächsten Zeile weiter. Andernfalls mit <code>return (this.noch != 0);</code>.",
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Das ist eine Wertezuweisung: Ermittle, welchen Wert <code>this.noch</code> gerade hat. Subtrahiere davon <code>1</code> und speichere das Ergebnis als <code>this.noch</code>, also als Variablenwert von <code>noch</code> im Objekt mit der Adresse <code>@0000</code>. Dann geht es nach der bedingten Anweisung mit <code>return (this.noch != 0);</code> weiter.",
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "<p><code>return</code> beendet den Methodenaufruf. Klicke daher auf ❌ &dash; aber nicht, bevor du den Rückgabewert <code>(this.noch != 0)</code> berechnet und ihn dir gemerkt hast: <code>!=</code> ist eine Vergleichsoperation, die prüft, ob zwei Werte ungleich sind. Rechts steht der Wert <code>0</code>, links <code>this.noch</code>. Den Wert von <code>this.noch</code> ermittelst du wie zuvor, der ist <code>2</code>. Weil <code>2</code> ungleich <code>0</code> ist, ist das Ergebnis der Vergleichsoperation <code>true</code>. Merken!</p><p>Du springst zurück zur Zeile mit dem Methodenaufruf. Das Ergebnis von <code>countdown.countdown()</code> ist der Rückgabewert <code>true</code>, das ist der Wert der Bedingung. Weil die Bedingung wahr ist, geht es mit der ersten Anweisung der inneren Sequenz weiter, also mit <code>println(countdown.noch + 1);</code>.</p>",
			"line": 10,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Berechne zunächst den Parameterwert, also <code>countdown.noch + 1</code>. <code>countdown</code> speichert die Adresse <code>@0000</code>, darum musst du vom zugehörigen Objekt den Wert des Attributs <code>noch</code> nehmen. Addiere zu diesem Wert (<code>2</code>) <code>1</code> und schreibe das Ergebnis <code>3</code> in die Textausgabe. Danach folgt ein Zeilenumbruch (weil <code>println</code> und nicht <code>print</code>). Damit ist die innere Sequenz vollständig abgearbeitet und es geht wieder mit der Prüfung der Bedingung weiter, also mit <code>while (countdown.countdown()) {</code>.",
			"line": 16,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Bei <code>while</code> musst du immer prüfen, ob die in Klammern stehende Bedingung den Wert <code>true</code> ergibt, also wahr ist. In diesem Fall ist die Bedingung der Methodenaufruf <code>countdown.countdown()</code>. Rufe daher zunächst die Methode <code>countdown</code> der Klasse <code>COUNTDOWN</code> auf.",
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "3\n"
		},
		{
			"task": "Bei jedem Methodenaufruf musst du zunächst den Wert von <code>this</code> richtig festsetzen. Weil der Methodenaufruf <code>countdown.countdown()</code> lautete, bekommt <code>this</code> den Wert von <code>countdown</code>, also die Adresse <code>@0000</code>. Da es keine Parameter gibt, geht es direkt mit der nächsten Zeile weiter.",
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Prüfe, ob die Bedingung in der Klammer erfüllt ist. Die Bedingung ist der Vergleich <code>this.noch &gt; 0</code>. Zunächst ermittelst du, was <code>this.noch</code> gerade für einen Wert hat: Da <code>this</code> die Adresse <code>@0000</code> enthält, kannst du den Attributwert von <code>noch</code> bei diesem Objekt ablesen. Prüfe, ob diese Zahl wirklich größer als <code>0</code> ist. Wenn ja, geht es in der nächsten Zeile weiter. Andernfalls mit <code>return (this.noch != 0);</code>.",
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Das ist eine Wertezuweisung: Ermittle, welchen Wert <code>this.noch</code> gerade hat. Subtrahiere davon <code>1</code> und speichere das Ergebnis als <code>this.noch</code>, also als Variablenwert von <code>noch</code> im Objekt mit der Adresse <code>@0000</code>. Dann geht es nach der bedingten Anweisung mit <code>return (this.noch != 0);</code> weiter.",
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "<p><code>return</code> beendet den Methodenaufruf. Klicke daher auf ❌ &dash; aber nicht, bevor du den Rückgabewert <code>(this.noch != 0)</code> berechnet und ihn dir gemerkt hast: <code>!=</code> ist eine Vergleichsoperation, die prüft, ob zwei Werte ungleich sind. Rechts steht der Wert <code>0</code>, links <code>this.noch</code>. Den Wert von <code>this.noch</code> ermittelst du wie zuvor, der ist <code>1</code>. Weil <code>1</code> ungleich <code>0</code> ist, ist das Ergebnis der Vergleichsoperation <code>true</code>. Merken!</p><p>Du springst zurück zur Zeile mit dem Methodenaufruf. Das Ergebnis von <code>countdown.countdown()</code> ist der Rückgabewert <code>true</code>, das ist der Wert der Bedingung. Weil die Bedingung wahr ist, geht es mit der ersten Anweisung der inneren Sequenz weiter, also mit <code>println(countdown.noch + 1);</code>.</p>",
			"line": 10,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Berechne zunächst den Parameterwert, also <code>countdown.noch + 1</code>. <code>countdown</code> speichert die Adresse <code>@0000</code>, darum musst du vom zugehörigen Objekt den Wert des Attributs <code>noch</code> nehmen. Addiere zu diesem Wert (<code>1</code>) <code>1</code> und fügst das Ergebnis <code>2</code> in die Textausgabe ein (ganz am Ende, in die bislang leere Zeile). Danach folgt ein Zeilenumbruch (weil <code>println</code> und nicht <code>print</code>). Damit ist die innere Sequenz vollständig abgearbeitet und es geht wieder mit der Prüfung der Bedingung weiter, also mit <code>while (countdown.countdown()) {</code>.",
			"line": 16,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Bei <code>while</code> musst du immer prüfen, ob die in Klammern stehende Bedingung den Wert <code>true</code> ergibt, also wahr ist. In diesem Fall ist die Bedingung der Methodenaufruf <code>countdown.countdown()</code>. Rufe daher zunächst die Methode <code>countdown</code> der Klasse <code>COUNTDOWN</code> auf.",
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "3\n2\n"
		},
		{
			"task": "Bei jedem Methodenaufruf musst du zunächst den Wert von <code>this</code> richtig festsetzen. Weil der Methodenaufruf <code>countdown.countdown()</code> lautete, bekommt <code>this</code> den Wert von <code>countdown</code>, also die Adresse <code>@0000</code>. Da es keine Parameter gibt, geht es direkt mit der nächsten Zeile weiter.",
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Prüfe, ob die Bedingung in der Klammer erfüllt ist. Die Bedingung ist der Vergleich <code>this.noch &gt; 0</code>. Zunächst ermittelst du, was <code>this.noch</code> gerade für einen Wert hat: Da <code>this</code> die Adresse <code>@0000</code> enthält, kannst du den Attributwert von <code>noch</code> bei diesem Objekt ablesen. Prüfe, ob diese Zahl wirklich größer als <code>0</code> ist. Wenn ja, geht es in der nächsten Zeile weiter. Andernfalls mit <code>return (this.noch != 0);</code>.",
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Das ist eine Wertezuweisung: Ermittle, welchen Wert <code>this.noch</code> gerade hat. Subtrahiere davon <code>1</code> und speichere das Ergebnis als <code>this.noch</code>, also als Variablenwert von <code>noch</code> im Objekt mit der Adresse <code>@0000</code>. Dann geht es nach der bedingten Anweisung mit <code>return (this.noch != 0);</code> weiter.",
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "<p><code>return</code> beendet den Methodenaufruf. Klicke daher auf ❌ &dash; aber nicht, bevor du den Rückgabewert <code>(this.noch != 0)</code> berechnet und ihn dir gemerkt hast: <code>!=</code> ist eine Vergleichsoperation, die prüft, ob zwei Werte ungleich sind. Rechts steht der Wert <code>0</code>, links <code>this.noch</code>. Den Wert von <code>this.noch</code> ermittelst du wie zuvor, der ist <code>0</code>. Weil <code>0</code> nicht ungleich <code>0</code> ist, ist das Ergebnis der Vergleichsoperation <code>false</code>. Merken!</p><p>Du springst zurück zur Zeile mit dem Methodenaufruf. Das Ergebnis von <code>countdown.countdown()</code> ist der Rückgabewert <code>false</code>, das ist der Wert der Bedingung. Weil die Bedingung nicht erfüllt ist, geht es mit der ersten Anweisung nach der inneren Sequenz weiter, also mit <code>print(\"Los!\");</code>.</p>",
			"line": 10,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Hänge nun das Wort <code>Los!</code> ganz ans Ende der Textausgabe (in die letzte Zeile!). Danach kommt kein Zeilenumbruch. Klicke anschließend auf <em>Fertig</em>.",
			"line": 18,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "COUNTDOWN",
						"atts": [
							{
								"key": "noch",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "countdown",
						"type": "COUNTDOWN",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "3\n2\nLos!"
		}
	]
};
